#
# Conditional build:
%bcond_without	opengl	# without OpenGL libraries
%bcond_without	xft	# without Xft support
#
Summary:	Fast Light Tool Kit
Summary(pl.UTF-8):	FLTK - "lekki" X11 toolkit
Summary(pt_BR.UTF-8):	Interface gráfica em C++ para X, OpenGL e Windows
Name:		fltk
Version:	1.3.3
Release:	2
License:	LGPL v2 with amendments (see COPYING)
Group:		X11/Libraries
Source0:	http://fltk.org/pub/fltk/%{version}/%{name}-%{version}-source.tar.gz
# Source0-md5:	9ccdb0d19dc104b87179bd9fd10822e3
Patch0:		%{name}-desktop.patch
Patch1:		%{name}-as-needed.patch
Patch2:		%{name}-link.patch
Patch3:		%{name}-libjpeg.patch
Patch4:		%{name}-export.patch
URL:		http://www.fltk.org/
%{?with_opengl:BuildRequires:	OpenGL-GLU-devel}
%{?with_opengl:BuildRequires:	OpenGL-GLX-devel}
BuildRequires:	autoconf >= 2.50
BuildRequires:	cairo-devel
BuildRequires:	doxygen
%{?with_xft:BuildRequires:	fontconfig-devel}
BuildRequires:	groff
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libstdc++-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.315
BuildRequires:	xorg-lib-libXcursor-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXfixes-devel
%{?with_xft:BuildRequires:	xorg-lib-libXft-devel}
BuildRequires:	xorg-lib-libXinerama-devel
BuildRequires:	xorg-util-makedepend
Obsoletes:	libfltk1.1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# don't propagate strip-flags to fltk-config.
%define		filterout_ld	(-Wl,)?-[sS] (-Wl,)?--strip.*

%description
The Fast Light Tool Kit ("FLTK", pronounced "fulltick") is a LGPL'd
C++ graphical user interface toolkit for X (UNIX(r)), OpenGL(r), and
Microsoft(r) Windows(r) NT 4.0, 95, or 98. It was originally developed
by Mr. Bill Spitzak and is currently maintained by a small group of
developers across the world with a central repository in the US.

%description -l pl.UTF-8
Fast Light Tool Kit ("FLTK", wymawiane "fultik"), jest rozprowadzanym
na licencji LGPL narzędziem do tworzenia graficznych interfejsów
użytkownika w C++ dla X (UNIX(r)), OpenGL(r), i Microsoft(r)
Windows(r) NT 4.0, 95, oraz 98. Jego pierwotnym autorem jest pan Bill
Spitzak; obecnie pakiet jest rozwijany przez niewielką grupę
deweloperów z różnych stron świata (centralne repozytorium znajduje
się w USA).

%description -l pt_BR.UTF-8
A Fast Light Tool Kit ("FLTK", pronuncia-se "fulltick") é uma
ferramenta e interface gráfica feita em C++ para desenvolver
aplicativos para o X, OpenGL e Windows.

%package devel
Summary:	FLTK development files
Summary(pl.UTF-8):	Narzędzia programistyczne dla FLTK
Summary(pt_BR.UTF-8):	Arquivos de inclusão para o FLTK
Group:		X11/Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libjpeg-devel
Requires:	libpng-devel
Requires:	libstdc++-devel
%{?with_xft:Requires:	xorg-lib-libXft-devel}
Requires:	xorg-lib-libXinerama-devel
Obsoletes:	libfltk1.1-devel

%description devel
FLTK development files.

%description devel -l pl.UTF-8
Narzędzia programistyczne dla FLTK.

%description devel -l pt_BR.UTF-8
Arquivos de inclusão para o FLTK.

%package static
Summary:	FLTK static library
Summary(pl.UTF-8):	Biblioteka FLTK konsolidowana statycznie
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para o FLTK
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
FLTK static library.

%description static -l pl.UTF-8
Biblioteka FLTK konsolidowana statycznie.

%description static -l pt_BR.UTF-8
Bibliotecas estáticas para o FLTK.

%package cairo
Summary:	FLTK Cairo library
Summary(pl.UTF-8):	Biblioteka FLTK Cairo
Group:		X11/Libraries
Requires:	%{name} = %{version}-%{release}

%description cairo
FLTK Cairo library.

%description cairo -l pl.UTF-8
Biblioteka FLTK Cairo.

%package cairo-devel
Summary:	Header files for FLTK Cairo library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki FLTK Cairo
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-cairo = %{version}-%{release}

%description cairo-devel
Header files for FLTK Cairo library.

%description cairo-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki FLTK Cairo.

%package cairo-static
Summary:	FLTK Cairo static library
Summary(pl.UTF-8):	Statyczna biblioteka FLTK Cairo
Group:		X11/Development/Libraries
Requires:	%{name}-cairo-devel = %{version}-%{release}

%description cairo-static
FLTK Cairo static library.

%description cairo-static -l pl.UTF-8
Statyczna biblioteka FLTK Cairo.

%package gl
Summary:	FLTK GL library
Summary(pl.UTF-8):	Biblioteka FLTK GL
Group:		X11/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	OpenGL

%description gl
FLTK GL library.

%description gl -l pl.UTF-8
Biblioteka FLTK GL.

%package gl-devel
Summary:	Header files for FLTK GL library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki FLTK GL
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-gl = %{version}-%{release}

%description gl-devel
Header files for FLTK GL library.

%description gl-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki FLTK GL.

%package gl-static
Summary:	FLTK GL static library
Summary(pl.UTF-8):	Statyczna biblioteka FLTK GL
Group:		X11/Development/Libraries
Requires:	%{name}-gl-devel = %{version}-%{release}
Requires:	%{name}-static = %{version}-%{release}

%description gl-static
FLTK GL static library.

%description gl-static -l pl.UTF-8
Statyczna biblioteka FLTK GL.

%package games
Summary:	FLTK Games
Summary(pl.UTF-8):	Gry FLTK
Group:		X11/Applications/Games
Requires:	%{name} = %{version}-%{release}

%description games
FLTK games: Block Attack!, Checkers, or Sudoku on your computer.

%description games -l pl.UTF-8
Gry FLTK: Atak Klocków!, Warcaby, Sudoku.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
# gold doesn't understand -l:path/to/library.so
if [ -x /usr/bin/ld.bfd ]; then
	install -d ld-dir
	ln -sf /usr/bin/ld.bfd ld-dir/ld
	export PATH=$(pwd)/ld-dir:$PATH
fi
%{__autoconf}
%configure \
	--enable-cairo \
	--enable-largefile \
	--enable-shared \
	--enable-threads \
	--enable-xinerama \
	--with-x \
	--with-optim="%{rpmcxxflags}" \
	%{!?with_opengl:--disable-gl} \
	%{?with_xft:--enable-xft}

%{__make}
cd documentation
%{__make} html

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	install-desktop \
	DESTDIR=$RPM_BUILD_ROOT

# less generic games' names
for f in blocks checkers sudoku ; do
%{__mv} $RPM_BUILD_ROOT%{_bindir}/{,fltk-}${f}
%{__mv} $RPM_BUILD_ROOT%{_mandir}/man6/{,fltk-}${f}.6
done

# we package mans in groff format
%{__rm} -r $RPM_BUILD_ROOT%{_mandir}/cat?

# add link to documentation for fluid help; remove /usr/share/doc/fltk contents - it is installed during make install
%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/doc/%{name}
ln -sf %{name}-devel-%{version} $RPM_BUILD_ROOT%{_datadir}/doc/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post   cairo -p /sbin/ldconfig
%postun cairo -p /sbin/ldconfig

%post   gl -p /sbin/ldconfig
%postun gl -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
# note: COPYING contains amendments to LGPL, so don't remove!
%doc CHANGES COPYING CREDITS README
%attr(755,root,root) %{_libdir}/libfltk.so.*.*
%attr(755,root,root) %{_libdir}/libfltk_forms.so.*.*
%attr(755,root,root) %{_libdir}/libfltk_images.so.*.*

%files devel
%defattr(644,root,root,755)
%doc documentation/html/*.{html,jpg,png}
%doc %{_datadir}/doc/%{name}
%attr(755,root,root) %{_bindir}/fltk-config
%attr(755,root,root) %{_bindir}/fluid
%attr(755,root,root) %{_libdir}/libfltk.so
%attr(755,root,root) %{_libdir}/libfltk_forms.so
%attr(755,root,root) %{_libdir}/libfltk_images.so
%{_includedir}/FL
%exclude %{_includedir}/FL/Fl_Cairo*.H
%exclude %{_includedir}/FL/Fl_Gl_Window.H
%exclude %{_includedir}/FL/gl*
%{_iconsdir}/hicolor/*/apps/fluid.png
%{_desktopdir}/fluid.desktop
# move to some KDE package?
#%{_datadir}/mimelnk/application/x-fluid.desktop
%{_mandir}/man1/fltk-config.1*
%{_mandir}/man1/fluid.1*
%{_mandir}/man3/fltk.3*

%files static
%defattr(644,root,root,755)
%{_libdir}/libfltk.a
%{_libdir}/libfltk_forms.a
%{_libdir}/libfltk_images.a

%files cairo
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfltk_cairo.so.*.*

%files cairo-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfltk_cairo.so
%{_includedir}/FL/Fl_Cairo*.H

%files cairo-static
%defattr(644,root,root,755)
%{_libdir}/libfltk_cairo.a

%if %{with opengl}
%files gl
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfltk_gl.so.*.*

%files gl-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfltk_gl.so
%{_includedir}/FL/Fl_Gl_Window.H
%{_includedir}/FL/gl*

%files gl-static
%defattr(644,root,root,755)
%{_libdir}/libfltk_gl.a
%endif

%files games
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/%{name}-blocks
%attr(755,root,root) %{_bindir}/%{name}-checkers
%attr(755,root,root) %{_bindir}/%{name}-sudoku
%{_iconsdir}/hicolor/*/apps/blocks.png
%{_iconsdir}/hicolor/*/apps/checkers.png
%{_iconsdir}/hicolor/*/apps/sudoku.png
%{_desktopdir}/blocks.desktop
%{_desktopdir}/checkers.desktop
%{_desktopdir}/sudoku.desktop
%{_mandir}/man6/%{name}-blocks.6*
%{_mandir}/man6/%{name}-checkers.6*
%{_mandir}/man6/%{name}-sudoku.6*
%changelog
* Fri Feb 27 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fltk.git;a=log;h=master

* Fri Feb 27 2015 Elan Ruusamäe <glen@delfi.ee> fcebd05
- x32 rebuild
- release 2 (by relup.sh)

* Wed Nov 19 2014 Jakub Bogusz <qboosh@pld-linux.org> 1163b41
- build cairo library

* Wed Nov 19 2014 Jakub Bogusz <qboosh@pld-linux.org> 33e36ae
- updated to 1.3.3
- updated as-needed patch
- added export patch (exports XFont interface needed by libfltk_gl library)

* Tue Oct 29 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> e1e2e8f
- release 3 (by relup.sh)

* Thu May 09 2013 Jakub Bogusz <qboosh@pld-linux.org> 8ac8300
- force ld.bfd

* Mon May 06 2013 Marcin Krol <hawk@tld-linux.org> cbb7d86
- release 2 (by relup.sh)

* Mon May 06 2013 Marcin Krol <hawk@tld-linux.org> f100404
- fix building with libjpeg 9

* Mon May 06 2013 Marcin Krol <hawk@tld-linux.org> 3a0c718
- updated to 1.3.2
- build html documentation from sources (BR doxygen)

* Fri Feb 10 2012 Adam Gołębiowski <adamg@pld-linux.org> 879c3d1
- release 2 (rebuild against libpng-1.5)

* Tue Dec 13 2011 Jakub Bogusz <qboosh@pld-linux.org> 7cf84cd
- updated BRs

* Tue Dec 13 2011 Jakub Bogusz <qboosh@pld-linux.org> ab1ed91
- cleanup

* Sun Dec 11 2011 witekfl <witekfl@pld-linux.org> 669b12d
- up to 1.3.0

* Sun Dec 11 2011 witekfl <witekfl@pld-linux.org> 9133bc0
- updated for 1.3.0

* Sun Dec 11 2011 witekfl <witekfl@pld-linux.org> bf0fcda
- new, patch for 1.3.0

* Sat Feb 05 2011 sparky <sparky@pld-linux.org> e1d0fca
- added missing lang tag to Summary

* Fri Feb 04 2011 sparky <sparky@pld-linux.org> 097d503
- %description for correct %package

* Thu Jan 28 2010 sparky <sparky@pld-linux.org> 9ef5757
- BR: groff

* Thu Jan 28 2010 Jan Rękorajski <baggins@pld-linux.org> 5c5d20b
- fix paths

* Thu Jan 28 2010 Jan Rękorajski <baggins@pld-linux.org> bc32d97
- renumber patches

* Thu Jan 28 2010 Jan Rękorajski <baggins@pld-linux.org> 66ec0b1
- up to 1.1.10

